import type { DSize } from '../../utils/types';
import React from 'react';
import { DFormGroup } from './FormGroup';
import { DFormItem } from './FormItem';
export interface DFormContextData {
    gLabelWidth: NonNullable<DFormProps['dLabelWidth']>;
    gLabelColon: NonNullable<DFormProps['dLabelColon']>;
    gRequiredType: NonNullable<DFormProps['dRequiredType']>;
    gLayout: NonNullable<DFormProps['dLayout']>;
    gInlineSpan: NonNullable<DFormProps['dInlineSpan']>;
    gFeedbackIcon: NonNullable<DFormProps['dFeedbackIcon']>;
    gSize?: DSize;
}
export declare const DFormContext: React.Context<DFormContextData | null>;
export interface DFormProps extends React.FormHTMLAttributes<HTMLFormElement> {
    dUpdate: () => void;
    dLabelWidth?: number | string;
    dLabelColon?: boolean;
    dRequiredType?: 'required' | 'optional' | 'hidden';
    dLayout?: 'horizontal' | 'vertical' | 'inline';
    dInlineSpan?: number | true;
    dFeedbackIcon?: boolean | {
        success?: React.ReactNode;
        warning?: React.ReactNode;
        error?: React.ReactNode;
        pending?: React.ReactNode;
    };
    dSize?: DSize;
}
export declare const DForm: {
    (props: DFormProps): JSX.Element | null;
    Group: typeof DFormGroup;
    Item: typeof DFormItem;
};
