import type { DId } from '../../utils/types';
import type { ComboboxKeyDownRef } from '../_keyboard';
import type { DTreeItem } from './Tree';
import type { AbstractTreeNode } from './abstract-node';
import React from 'react';
export interface DPanelProps<V extends DId, T extends DTreeItem<V>> extends Omit<React.HTMLAttributes<HTMLElement>, 'children'> {
    dGetGroupId: (value: V) => string;
    dGetItemId: (value: V) => string;
    dList: AbstractTreeNode<V, T>[];
    dExpandIds: Set<V>;
    dHeight: number;
    dPadding: number | undefined;
    dFocusItem: AbstractTreeNode<V, T> | undefined;
    dCustomItem: ((item: T) => React.ReactNode) | undefined;
    dShowLine: boolean;
    dMultiple: boolean;
    dFocusVisible: boolean;
    onFocusChange: (node: AbstractTreeNode<V, T>) => void;
    onExpandChange: (node: AbstractTreeNode<V, T>) => void;
    onClickItem: (node: AbstractTreeNode<V, T>) => void;
}
declare function Panel<V extends DId, T extends DTreeItem<V>>(props: DPanelProps<V, T>, ref: React.ForwardedRef<ComboboxKeyDownRef>): JSX.Element | null;
export declare const DPanel: <V extends DId, T extends DTreeItem<V>>(props: DPanelProps<V, T> & React.RefAttributes<ComboboxKeyDownRef>) => ReturnType<typeof Panel>;
export {};
